<?php

function getmicrotime(){
    list($usec, $sec) = explode(" ",microtime());
    return ((float)$usec + (float)$sec);
}

function prepare_string($string) {
	
	$string = addslashes($string);
	
	// thanks to PMA
	$search       = array("\x00", "\x0a", "\x0d", "\x1a"); //\x08\\x09, not required
    $replace      = array('\0', '\n', '\r', '\Z');
    
	$string = str_replace($search, $replace, $string);
	
	return($string);
}

if(!isset($_GET['zones'])) header("LOCATION: vamshop2-export/index.html");

$start = getmicrotime();

include('includes/application_top.php');

// process the customers data
// We don't drop the table, because of the Superuser

$fc .= "set sql_mode='';\n";
$fc .= "set names utf8;\n";


$fc .= "
truncate table attributes;
truncate table attribute_descriptions;
truncate table contents_contents;
truncate table content_articles;
truncate table content_news;
truncate table content_products;

delete from contents where id = 36;
delete from contents where id = 38;
delete from contents where id = 39;
delete from contents where id = 43;
delete from contents where id = 71;
delete from contents where id = 72;
delete from contents where id = 93;
delete from contents where id = 94;
delete from contents where id = 95;
delete from contents where id = 96;
delete from contents where id = 97;
delete from contents where id = 98;
delete from contents where id = 99;
delete from contents where id = 100;
delete from contents where id = 101;
delete from contents where id = 102;
delete from contents where id = 103;
delete from contents where id = 104;
delete from contents where id = 108;

delete from content_categories where content_id = 36;
delete from content_categories where content_id = 39;
delete from content_categories where content_id = 43;
delete from content_categories where content_id = 101;

delete from content_descriptions where content_id = 36;
delete from content_descriptions where content_id = 38;
delete from content_descriptions where content_id = 39;
delete from content_descriptions where content_id = 43;
delete from content_descriptions where content_id = 71;
delete from content_descriptions where content_id = 72;
delete from content_descriptions where content_id = 93;
delete from content_descriptions where content_id = 94;
delete from content_descriptions where content_id = 95;
delete from content_descriptions where content_id = 96;
delete from content_descriptions where content_id = 97;
delete from content_descriptions where content_id = 98;
delete from content_descriptions where content_id = 99;
delete from content_descriptions where content_id = 100;
delete from content_descriptions where content_id = 102;
delete from content_descriptions where content_id = 103;
delete from content_descriptions where content_id = 104;
delete from content_descriptions where content_id = 108;

delete from content_manufacturers where content_id = 108;
";

$fc .= "\n\n# Table: customers, address_books\n";
$fc .= "DELETE FROM address_books;\n";
$fc .= "DELETE FROM customers;\n";

$customers_sql = vam_db_query("SELECT * FROM ".TABLE_CUSTOMERS);
$customers_count = vam_db_num_rows($customers_sql);
$i = 1;
$address_book_count = 0;
while($customers = vam_db_fetch_array($customers_sql)) {
	if($customers['customers_id'] != '1') {
		$address_book_sql = vam_db_query("SELECT * FROM ".TABLE_ADDRESS_BOOK." WHERE customers_id = ".$customers['customers_id']);
		while($address_book = vam_db_fetch_array($address_book_sql)) {
			$i++;
			if($customers['customers_default_address_id'] == $address_book['address_book_id']) {
				$default = $i;
			}
			$address_book_count++;
			$fc .= "INSERT INTO address_books VALUES ('".$i."', '".$address_book['customers_id']."', '".prepare_string($address_book['entry_firstname']).' '.prepare_string($address_book['entry_lastname'])."', '".prepare_string($address_book['entry_street_address'])."', '', '".prepare_string($address_book['entry_city'])."', '".prepare_string($address_book['entry_state'])."', '".$address_book['entry_country_id']."', '".prepare_string($address_book['entry_postcode'])."', '".prepare_string($customers['customers_telephone'])."', 'now()', 'now()');\n";
		}
		$fc .= "INSERT INTO customers VALUES ('".$customers['customers_id']."', '', '', '', '', '".prepare_string($customers['customers_firstname']).' '.prepare_string($customers['customers_lastname'])."', '".prepare_string($customers['customers_email_address'])."', '".prepare_string($customers['customers_password'])."', '','','','','','','','','', '', '', '', '', '', '');\n";
	}
}


$fc .= "\n\n# Table: orders\n";
$fc .= "DELETE FROM orders;\n";
	   
$orders_sql = vam_db_query("SELECT * FROM ".TABLE_ORDERS);
$orders_count = vam_db_num_rows($orders_sql);
$unorder = array();
while($orders = vam_db_fetch_array($orders_sql)) {
	if($orders['customers_id'] != '1') {
		if(isset($orders['comments'])) {
			$comments = $orders['comments'];
		}
		else {
			$comments = '';
		}

$shipping_query = vam_db_query("select value from " . TABLE_ORDERS_TOTAL . " where orders_id = '" . vam_db_input($orders['orders_id']) . "' and class = 'ot_shipping'");
$shipping = vam_db_fetch_array($shipping_query);

$tax_query = vam_db_query("select value from " . TABLE_ORDERS_TOTAL . " where orders_id = '" . vam_db_input($orders['orders_id']) . "' and class = 'ot_tax'");
$tax = vam_db_fetch_array($tax_query);

$total_query = vam_db_query("select value from " . TABLE_ORDERS_TOTAL . " where orders_id = '" . vam_db_input($orders['orders_id']) . "' and class = 'ot_total'");
$total = vam_db_fetch_array($total_query);


		$fc .= "INSERT INTO orders VALUES ('".$orders['orders_id']."', '".$orders['customers_id']."', '".$orders['orders_status']."', '2', '2', '".number_format($shipping['value'],2,'.','')."', '".number_format($tax['value'],2,'.','')."', '".number_format($total['value'],2,'.','')."', '".prepare_string($orders['billing_name'])."', '".prepare_string($orders['billing_street_address'])."', '', '".prepare_string($orders['billing_city'])."', '".prepare_string($orders['billing_state'])."', '".prepare_string($orders['billing_country'])."', '".$orders['billing_postcode']."', '".prepare_string($orders['delivery_name'])."', '".prepare_string($orders['delivery_street_address'])."', '', '".prepare_string($orders['delivery_city'])."', '".prepare_string($orders['delivery_state'])."', '".prepare_string($orders['delivery_country'])."', '".$orders['delivery_postcode']."', '".$orders['customers_email_address']."', '".$orders['customers_telephone']."', '".$orders['customers_company']."', '', '', '".$orders['date_purchased']."','','','','','','','');\n";

	}
	else {
		$unorder[] = $orders['orders_id'];
	}
}
$fc .= "\n\n# Table: order_products\n";
$fc .= "DELETE FROM order_products;\n";
	   
$orders_products_sql = vam_db_query("SELECT * FROM ".TABLE_ORDERS_PRODUCTS);
$orders_products_count = vam_db_num_rows($orders_products_sql);
while($orders_products = vam_db_fetch_array($orders_products_sql)) {
	if(!in_array($orders_products['orders_id'], $unorder)) {
		$fc .= "INSERT INTO order_products VALUES ('".$orders_products['orders_products_id']."', '".$orders_products['orders_id']."', '".$orders_products['products_id']."', '".prepare_string($orders_products['products_name'])."', '".prepare_string($orders_products['products_model'])."', '".prepare_string($orders_products['products_model'])."', '".$orders_products['products_quantity']."', '".number_format(($orders_products['products_price']/(1+($orders_products['products_tax']/100))),2,'.','')."', '".$orders_products['products_weight']."', NULL, NULL, NULL, NULL, '0', '0', NULL, '".$orders['orders_status']."','','','','');\n";
	}
	else {
		$orders_products_count--;
	}
}

$fc .= "\n\n# Table: order_comments\n";
$fc .= "DELETE FROM order_comments;\n";

$orders_status_history_sql = vam_db_query("SELECT * FROM ".TABLE_ORDERS_STATUS_HISTORY);
while($orders_status_history = vam_db_fetch_array($orders_status_history_sql)) {
	if(!in_array($orders_status_history['orders_id'], $unorder)) {
		if(isset($orders_status_history['new_value'])) {
			$orders_status_id = $orders_status_history['new_value'];
		}
		else {
			$orders_status_id = $orders_status_history['orders_status_id'];
		}
		if(isset($orders_status_history['comments'])) {
			$comments = $orders_status_history['comments'];
		}
		else {
			$comments = '';
		}
		$fc .= "INSERT INTO order_comments VALUES ('".$orders_status_history['orders_status_history_id']."', '".$orders['customers_id']."', '".$orders_status_history['orders_id']."', '1', '".prepare_string($comments)."', '".$orders_status_history['date_added']."', '".$orders_status_history['date_added']."');\n";
	}
}

// process the orders status

$fc .= "\n\n# Table: order_statuses, order_status_descriptions\n";
$fc .= "DELETE FROM order_statuses;\n";
$fc .= "DELETE FROM order_status_descriptions;\n";
$orders_status_sql = vam_db_query("SELECT * FROM ".TABLE_ORDERS_STATUS." where language_id = 1");
$orders_status_count = vam_db_num_rows($orders_status_sql);
while($orders_status = vam_db_fetch_array($orders_status_sql)) {
	$fc .= "INSERT INTO order_statuses VALUES ('".$orders_status['orders_status_id']."', '".(($orders_status['orders_status_id'] == 1) ? "1" : "0")."', '".prepare_string($orders_status['orders_status_id'])."');\n";
	$fc .= "INSERT INTO order_status_descriptions VALUES ('".$orders_status['orders_status_id']."', '".$orders_status['orders_status_id']."', '2', '".prepare_string($orders_status['orders_status_name'])."', '');\n";
}


// process the categories

$fc .= "\n\n# Table: contents\n";

$categories_sql = vam_db_query("SELECT * FROM ".TABLE_CATEGORIES." as c, ".TABLE_CATEGORIES_DESCRIPTION." as cd where cd.categories_id = c.categories_id and cd.language_id = 1");
$categories_count = vam_db_num_rows($categories_sql);
$categories_images_count = 0;
while($categories = vam_db_fetch_array($categories_sql)) {
$categories['categories_id'] = $categories['categories_id'] + 200;
$categories['parent_id'] = $categories['parent_id'] + 200;

	$fc .= "INSERT INTO contents VALUES ('".$categories['categories_id']."', '".(($categories['parent_id'] > 200) ? $categories['parent_id'] : 0)."', '".$categories['sort_order']."', '0', '1', '1', '0', '".($categories['categories_url'] != '' ? str_replace('.html','',$categories['categories_url']) : $categories['categories_id'])."', '', '".$categories['categories_status']."', '".$categories['categories_status']."', '1', '0', NULL, NULL, '".$categories['date_added']."', '".$categories['last_modified']."');\n";
	$fc .= "INSERT INTO content_descriptions VALUES (NULL, '".$categories['categories_id']."', '2', '".prepare_string($categories['categories_name'])."', '".prepare_string($categories['categories_description'])."', '".prepare_string($categories['categories_description'])."', '".prepare_string($categories['categories_meta_title'])."', '".prepare_string($categories['categories_meta_description'])."', '".prepare_string($categories['categories_meta_keywords'])."');\n";
	$fc .= "INSERT INTO content_categories VALUES (NULL, '".$categories['categories_id']."', '', '1');\n";
	if ($categories['categories_image'] != '') $fc .= "INSERT INTO content_images VALUES (NULL, '".$categories['categories_id']."', '1', '".vam_db_input($categories['categories_image'])."', '".$categories['date_added']."', '".$categories['last_modified']."');\n";
	// copy the image
	if(file_exists('images/categories/'.$categories['categories_image'])) {
		if(!strstr($categories['categories_image'], '/')) {
			
			$cat_directory = 'vamshop2-export/app/webroot/img/content';
			if(!is_dir($cat_directory)) {
				mkdir($cat_directory);
			}			

			@copy('images/categories/'.$categories['categories_image'], $cat_directory.'/'.$categories['categories_image']);
			$categories_images_count++;
		}
	}
}

// process the products data

$fc .= "\n\n# Table: contents\n";

$products_sql = vam_db_query("SELECT * FROM ".TABLE_PRODUCTS." as p, ".TABLE_PRODUCTS_DESCRIPTION." as pd, ".TABLE_PRODUCTS_TO_CATEGORIES." as p2c where p2c.products_id = p.products_id and pd.products_id = p.products_id and pd.language_id = 1 group by p.products_id");
$products_count = vam_db_num_rows($products_sql);
$products_images_count = 0;
while($products = vam_db_fetch_array($products_sql)) {
$products['products_id'] = $products['products_id'] + 1000;
$products['categories_id'] = $products['categories_id'] + 200;

	$fc .= "INSERT INTO contents VALUES ('".$products['products_id']."', '".(($products['categories_id'] > 200) ? $products['categories_id'] : 0)."', '".$products['products_sort']."', '0', '2', '1', '0', '".($products['products_page_url'] != '' ? str_replace('.html','',$products['products_page_url']) : $products['products_id'])."', '', '".$products['products_status']."', '1', '1', '0', NULL, NULL, '".$products['products_date_added']."', '".$products['products_last_modified']."');\n";
	$fc .= "INSERT INTO content_descriptions VALUES (NULL, '".$products['products_id']."', '2', '".prepare_string($products['products_name'])."', '".prepare_string($products['products_description'])."', '".prepare_string($products['products_short_description'])."', '".prepare_string($products['products_meta_title'])."', '".prepare_string($products['products_meta_description'])."', '".prepare_string($products['products_meta_keywords'])."');\n";
	$fc .= "INSERT INTO content_products VALUES (NULL, '".$products['products_id']."', '', '', '".$products['products_quantity']."', '".prepare_string($products['products_model'])."', '', '".number_format($products['products_price'],2,'.','')."', '1', '".$products['products_weight']."', '1', '1', '0','','','','', '', '');\n";
	if ($products['products_image'] != '') $fc .= "INSERT INTO content_images VALUES (NULL, '".$products['products_id']."', '1', '".prepare_string($products['products_image'])."', '".$products['products_date_added']."', '".$products['products_last_modified']."');\n";
	// copy the image
	if(file_exists('images/product_images/original_images/'.$products['products_image'])) {
		if(!strstr($products['products_image'], '/')) {
			
			$prod_directory = 'vamshop2-export/app/webroot/img/content';
			if(!is_dir($prod_directory)) {
				mkdir($prod_directory);
			}			

			@copy('images/product_images/original_images/'.$products['products_image'], $prod_directory.'/'.$products['products_image']);
			$products_images_count++;
		}
	}
}
	   
// process the product reviews

$fc .= "\n\n# Table: module_reviews\n";
$fc .= "DELETE FROM module_reviews;\n";

$reviews_sql = vam_db_query("SELECT * FROM ".TABLE_REVIEWS." as r, ".TABLE_REVIEWS_DESCRIPTION." as rd where rd.reviews_id = r.reviews_id and rd.languages_id='1'");
$reviews_count = vam_db_num_rows($reviews_sql);
$unreview = array();
while($reviews = vam_db_fetch_array($reviews_sql)) {
	$reviews['products_id'] = $reviews['products_id']+1000;
	if($reviews['customers_id'] != '1') {
		$fc .= "INSERT INTO module_reviews VALUES ('".$reviews['reviews_id']."', '".$reviews['products_id']."', '".prepare_string($reviews['customers_name'])."', '".prepare_string(prepare_string($reviews['reviews_text']))."', '".$reviews['reviews_rating']."', '".$reviews['date_added']."', '".$reviews['last_modified']."');\n";
	}
	else {
		$reviews_count--;
		$unreview[] = $reviews['reviews_id'];
	}
}

// process xsell

$fc .= "\n\n# Table: contents_contents\n";
$fc .= "DELETE FROM contents_contents;\n";

$xsell_sql = vam_db_query("SELECT * FROM ".TABLE_PRODUCTS_XSELL."");
$xsell_count = vam_db_num_rows($xsell_sql);
while($xsell = vam_db_fetch_array($xsell_sql)) {
	$xsell['products_id'] = $xsell['products_id']+1000;
	$xsell['xsell_id'] = $xsell['xsell_id']+1000;
		$fc .= "INSERT INTO contents_contents VALUES ('".$xsell['ID']."', '".$xsell['products_id']."', '".$xsell['xsell_id']."');\n";
}

// create the sql-dump-file
$fp = fopen('vamshop2-export/vamshop2-export.sql', w);
if (!fputs($fp, $fc)) die('unable to create file!');
fclose($fp);

$end = getmicrotime();

$duration = $end-$start;

$filesize = filesize('vamshop2-export/vamshop2-export.sql');
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>

	<head>
		<meta http-equiv="content-type" content="text/html;charset=utf-8">
		<title>VamShop 2 Export</title>
	</head>

	<body>

Информация:<br />
Время исполнения: <?php echo round($duration,4);?> секунд<br />
Размер файла: <?php echo $filesize;?> байт<br />
<br />
Конвертированы следующие данные (количество записей):<br />
<br />
Покупатели: <?php echo $customers_count;?><br />
Отзывы: <?php echo $reviews_count;?><br />
<br />
Товары: <?php echo $products_count;?><br />
Картинки товаров: <?php echo $products_images_count;?><br />
<br />
Категории: <?php echo $categories_count;?><br />
Картинки категорий: <?php echo $categories_images_count;?><br />
<br />
Заказы: <?php echo $orders_count;?><br />
Заказанные товары: <?php echo $orders_products_count;?><br />
Статусы заказов: <?php echo $orders_status_count;?><br />

	</body>
</html>
